unit UfrmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComObj, ActiveX, AutoCAD_TLB, AcadEvents;

type
  TfrmMain = class(TForm)
    pnlLog: TPanel;
    memLog: TMemo;
    pnlCtrl: TPanel;
    btnConnect: TButton;
    procedure btnConnectClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OnDocBeginSave(Sender: TObject; const AFileName: WideString);
    procedure OnDocEndSave(Sender: TObject; const AFileName: WideString);
    procedure OnDocBeginCommand(Sender: TObject; const ACommand: WideString);
    procedure OnDocEndCommand(Sender: TObject; const ACommand: WideString);
    procedure OnDocBeginLisp(Sender: TObject; const AFirstLine: WideString);
    procedure OnDocEndLisp(Sender: TObject);
    procedure OnDocLispCancelled(Sender: TObject);
    procedure OnDocSelectionChanged(Sender: TObject);
    procedure OnDocActivate(Sender: TObject);
    procedure OnDocDeactivate(Sender: TObject);
    procedure OnDocBeginRightClick(Sender: TObject; APickPoint: OleVariant);
    procedure OnDocBeginShortcutMenuDefault(Sender: TObject; AMenu: OleVariant);
    procedure OnDocBeginShortcutMenuEdit(Sender: TObject; AMenu: OleVariant; ASet: OleVariant);
    procedure OnDocBeginShortcutMenuCommand(Sender: TObject; AMenu: OleVariant; const ACommand: WideString);
    procedure OnDocBeginShortcutMenuGrip(Sender: TObject; AMenu: OleVariant);
    procedure OnDocBeginShortcutMenuOsnap(Sender: TObject; AMenu: OleVariant);
    procedure OnDocEndShortcutMenu(Sender: TObject; AMenu: OleVariant);
    procedure OnDocBeginDoubleClick(Sender: TObject; APickPoint: OleVariant);
    procedure OnDocObjectAdded(Sender: TObject; AObject: OleVariant);
    procedure OnDocObjectErased(Sender: TObject; AObjectID: Integer);
    procedure OnDocObjectModified(Sender: TObject; AObject: OleVariant);
    procedure OnDocBeginPlot(Sender: TObject; const ADrawingName: WideString);
    procedure OnDocEndPlot(Sender: TObject; const ADrawingName: WideString);
    procedure OnDocWindowMoved(Sender: TObject; AHandle: Integer; AMoved: WordBool);
    procedure OnDocLayoutSwitched(Sender: TObject; const ALayoutName: WideString);
    procedure OnDocWindowChanged(Sender: TObject; AState: TOleEnum);
    procedure OnDocBeginClose(Sender: TObject);
    procedure OnDocBeginDocClose(Sender: TObject; var ACancel: WordBool);
    procedure OnDocUnknownEvent(Sender: TObject; ADispID: TDispID);
  private
  public
  end;

var
  frmMain: TfrmMain;
  Acad: OleVariant;
  CPC: IConnectionPointContainer;
  CP: IConnectionPoint;
  Cookie: Longint;

implementation

{$R *.dfm}

procedure TfrmMain.btnConnectClick(Sender: TObject);
begin
  if AcadConnect then
  begin
    pnlCtrl.Caption:= 'C...';
    btnConnect.Enabled:= False;
    AcadDocEvents.OnBeginSave:= OnDocBeginSave;
    AcadDocEvents.OnEndSave:= OnDocEndSave;
    AcadDocEvents.OnBeginCommand:= OnDocBeginCommand;
    AcadDocEvents.OnEndCommand:= OnDocEndCommand;
    AcadDocEvents.OnBeginLisp:= OnDocBeginLisp;
    AcadDocEvents.OnEndLisp:= OnDocEndLisp;
    AcadDocEvents.OnLispCancelled:= OnDocLispCancelled;
    AcadDocEvents.OnSelectionChanged:= OnDocSelectionChanged;
    AcadDocEvents.OnActivate:= OnDocActivate;
    AcadDocEvents.OnDeactivate:= OnDocDeactivate;
    AcadDocEvents.OnBeginRightClick:= OnDocBeginRightClick;
    AcadDocEvents.OnBeginShortcutMenuDefault:= OnDocBeginShortcutMenuDefault;
    AcadDocEvents.OnBeginShortcutMenuEdit:= OnDocBeginShortcutMenuEdit;
    AcadDocEvents.OnBeginShortcutMenuCommand:= OnDocBeginShortcutMenuCommand;
    AcadDocEvents.OnBeginShortcutMenuGrip:= OnDocBeginShortcutMenuGrip;
    AcadDocEvents.OnBeginShortcutMenuOsnap:= OnDocBeginShortcutMenuOsnap;
    AcadDocEvents.OnEndShortcutMenu:= OnDocEndShortcutMenu;
    AcadDocEvents.OnBeginDoubleClick:= OnDocBeginDoubleClick;
    AcadDocEvents.OnObjectAdded:= OnDocObjectAdded;
    AcadDocEvents.OnObjectErased:= OnDocObjectErased;
    AcadDocEvents.OnObjectModified:= OnDocObjectModified;
    AcadDocEvents.OnBeginPlot:= OnDocBeginPlot;
    AcadDocEvents.OnEndPlot:= OnDocEndPlot;
    AcadDocEvents.OnWindowMovedOrResized:= OnDocWindowMoved;
    AcadDocEvents.OnLayoutSwitched:= OnDocLayoutSwitched;
    AcadDocEvents.OnWindowChanged:= OnDocWindowChanged;
    AcadDocEvents.OnBeginClose:= OnDocBeginClose;
    AcadDocEvents.OnBeginDocClose:= OnDocBeginDocClose;
    AcadDocEvents.OnUnknownEvent:= OnDocUnknownEvent;
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Caption:= Application.Title;
  AcadDocEvents:= TAcadDocumentEvents.Create(Self);
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  AcadRelease;
  AcadDocEvents.Free;
end;

procedure TfrmMain.OnDocActivate(Sender: TObject);
begin
  memLog.Lines.Add('Activate');
end;

procedure TfrmMain.OnDocBeginCommand(Sender: TObject; const ACommand: WideString);
begin
  memLog.Lines.Add(Format('BeginCommand "%s"', [ACommand]));
end;

procedure TfrmMain.OnDocBeginLisp(Sender: TObject; const AFirstLine: WideString);
begin
  memLog.Lines.Add(Format('BeginLisp "%s"', [AFirstLine]));
end;

procedure TfrmMain.OnDocBeginRightClick(Sender: TObject;
  APickPoint: OleVariant);
begin
  memLog.Lines.Add(Format('BeginRightClick [%f; %f; %f]', [Double(APickPoint[0]), Double(APickPoint[1]), Double(APickPoint[2])]));
end;

procedure TfrmMain.OnDocBeginSave(Sender: TObject; const AFileName: WideString);
begin
  memLog.Lines.Add(Format('BeginSave "%s"', [AFileName]));
end;

procedure TfrmMain.OnDocBeginShortcutMenuDefault(Sender: TObject; AMenu: OleVariant);
begin
  memLog.Lines.Add(Format('BeginShortcutMenuDefault "%s"', [AMenu.Name]));
end;

procedure TfrmMain.OnDocBeginShortcutMenuEdit(Sender: TObject; AMenu,
  ASet: OleVariant);
begin
  memLog.Lines.Add(Format('BeginShortcutMenuEdit "%s" SelectionSet "%s"', [AMenu.Name, ASet.Name]));
end;

procedure TfrmMain.OnDocDeactivate(Sender: TObject);
begin
  memLog.Lines.Add('Deactivate');
end;

procedure TfrmMain.OnDocEndCommand(Sender: TObject; const ACommand: WideString);
begin
  memLog.Lines.Add(Format('EndCommand "%s"', [ACommand]));
end;

procedure TfrmMain.OnDocEndLisp(Sender: TObject);
begin
  memLog.Lines.Add('EndLisp');
end;

procedure TfrmMain.OnDocEndSave(Sender: TObject; const AFileName: WideString);
begin
  memLog.Lines.Add(Format('EndSave "%s"', [AFileName]));
end;

procedure TfrmMain.OnDocLispCancelled(Sender: TObject);
begin
  memLog.Lines.Add('LispCancelled');
end;

procedure TfrmMain.OnDocSelectionChanged(Sender: TObject);
begin
  memLog.Lines.Add('SelectionChanged');
end;

procedure TfrmMain.OnDocBeginShortcutMenuCommand(Sender: TObject;
  AMenu: OleVariant; const ACommand: WideString);
begin
  memLog.Lines.Add(Format('BeginShortcutMenuCommand "%s" Command "%s"', [AMenu.Name, ACommand]));
end;

procedure TfrmMain.OnDocBeginShortcutMenuGrip(Sender: TObject;
  AMenu: OleVariant);
begin
  memLog.Lines.Add(Format('BeginShortcutMenuGrip "%s"', [AMenu.Name]));
end;

procedure TfrmMain.OnDocBeginShortcutMenuOsnap(Sender: TObject;
  AMenu: OleVariant);
begin
  memLog.Lines.Add(Format('BeginShortcutMenuOsnap "%s"', [AMenu.Name]));
end;

procedure TfrmMain.OnDocEndShortcutMenu(Sender: TObject; AMenu: OleVariant);
begin
  memLog.Lines.Add(Format('EndShortcutMenu "%s"', [AMenu.Name]));
end;

procedure TfrmMain.OnDocBeginDoubleClick(Sender: TObject;
  APickPoint: OleVariant);
begin
  memLog.Lines.Add(Format('BeginDoubleClick [%f; %f; %f]', [Double(APickPoint[0]), Double(APickPoint[1]), Double(APickPoint[2])]));
end;

procedure TfrmMain.OnDocObjectAdded(Sender: TObject; AObject: OleVariant);
begin
  memLog.Lines.Add(Format('ObjectAdded "%s"', [AObject.ObjectName]));
end;

procedure TfrmMain.OnDocObjectErased(Sender: TObject; AObjectID: Integer);
begin
  memLog.Lines.Add(Format('ObjectErased "%d"', [AObjectID]));
end;

procedure TfrmMain.OnDocObjectModified(Sender: TObject; AObject: OleVariant);
begin
  memLog.Lines.Add(Format('ObjectModified "%s"', [AObject.ObjectName]));
end;

procedure TfrmMain.OnDocBeginPlot(Sender: TObject;
  const ADrawingName: WideString);
begin
  memLog.Lines.Add(Format('BeginPlot "%s"', [ADrawingName]));
end;

procedure TfrmMain.OnDocEndPlot(Sender: TObject;
  const ADrawingName: WideString);
begin
  memLog.Lines.Add(Format('EndPlot "%s"', [ADrawingName]));
end;

procedure TfrmMain.OnDocWindowMoved(Sender: TObject; AHandle: Integer;
  AMoved: WordBool);
begin
  memLog.Lines.Add(Format('WindowMoved "%d", "%s"', [AHandle, BoolToStr(Boolean(AMoved), True)]));
end;

procedure TfrmMain.OnDocLayoutSwitched(Sender: TObject;
  const ALayoutName: WideString);
begin
  memLog.Lines.Add(Format('LayoutSwitched "%s"', [ALayoutName]));
end;

procedure TfrmMain.OnDocWindowChanged(Sender: TObject; AState: TOleEnum);
begin
  memLog.Lines.Add(Format('WindowChanged "%d"', [AState]));
end;

procedure TfrmMain.OnDocBeginClose(Sender: TObject);
begin
  memLog.Lines.Add('BeginClose');
end;

procedure TfrmMain.OnDocBeginDocClose(Sender: TObject; var ACancel: WordBool);
begin
  memLog.Lines.Add(Format('BeginDocClose "%s"', [BoolToStr(Boolean(ACancel), True)]));
end;

procedure TfrmMain.OnDocUnknownEvent(Sender: TObject; ADispID: TDispID);
begin
  memLog.Lines.Add('UnknownEvent "%d"' + IntToStr(ADispID));
end;

end.
