unit UfrmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComObj, ActiveX, AutoCAD_TLB;

type
  TfrmMain = class(TForm)
    pnlLog: TPanel;
    memLog: TMemo;
    pnlCtrl: TPanel;
    btnConnect: TButton;
    btnClear: TButton;
    procedure btnConnectClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    // Application Events
    procedure OnAppSysVarChanged(Sender: TObject; const AName: WideString; AValue: OleVariant);
    procedure OnAppNewDrawing(Sender: TObject);
    procedure OnAppAppActivate(Sender: TObject);
    procedure OnAppAppDeactivate(Sender: TObject);
    procedure OnAppWindowMoved(Sender: TObject; AHandle: Integer; AMoved: WordBool);
    procedure OnAppBeginModal(Sender: TObject);
    procedure OnAppEndModal(Sender: TObject);
    procedure OnAppBeginQuit(Sender: TObject; var ACancel: WordBool);
    procedure OnAppBeginFileDrop(Sender: TObject; const AName: WideString; var ACancel: WordBool);
    procedure OnAppArxLoaded(Sender: TObject; const AAppName: WideString);
    procedure OnAppArxUnloaded(Sender: TObject; const AAppName: WideString);
    procedure OnAppBeginPlot(Sender: TObject; const ADrawingName: WideString);
    procedure OnAppEndPlot(Sender: TObject; const ADrawingName: WideString);
    procedure OnAppBeginLisp(Sender: TObject; const AFirstLine: WideString);
    procedure OnAppEndLisp(Sender: TObject);
    procedure OnAppBeginCommand(Sender: TObject; const ACommand: WideString);
    procedure OnAppEndCommand(Sender: TObject; const ACommand: WideString);
    procedure OnAppBeginSave(Sender: TObject; const AFileName: WideString);
    procedure OnAppEndSave(Sender: TObject; const AFileName: WideString);
    procedure OnAppBeginOpen(Sender: TObject; const AFileName: WideString);
    procedure OnAppEndOpen(Sender: TObject; const AFileName: WideString);
    procedure OnAppLispCancelled(Sender: TObject);
    procedure OnAppWindowChanged(Sender: TObject; AState: TOleEnum);
    procedure OnAppUnknownEvent(Sender: TObject; ADispID: TDispID);
    // Document Events
    procedure OnDocBeginSave(Sender: TObject; const AFileName: WideString);
    procedure OnDocEndSave(Sender: TObject; const AFileName: WideString);
    procedure OnDocBeginCommand(Sender: TObject; const ACommand: WideString);
    procedure OnDocEndCommand(Sender: TObject; const ACommand: WideString);
    procedure OnDocBeginLisp(Sender: TObject; const AFirstLine: WideString);
    procedure OnDocEndLisp(Sender: TObject);
    procedure OnDocLispCancelled(Sender: TObject);
    procedure OnDocSelectionChanged(Sender: TObject);
    procedure OnDocActivate(Sender: TObject);
    procedure OnDocDeactivate(Sender: TObject);
    procedure OnDocBeginRightClick(Sender: TObject; APickPoint: OleVariant);
    procedure OnDocBeginShortcutMenuDefault(Sender: TObject; AMenu: OleVariant);
    procedure OnDocBeginShortcutMenuEdit(Sender: TObject; AMenu: OleVariant; ASet: OleVariant);
    procedure OnDocBeginShortcutMenuCommand(Sender: TObject; AMenu: OleVariant; const ACommand: WideString);
    procedure OnDocBeginShortcutMenuGrip(Sender: TObject; AMenu: OleVariant);
    procedure OnDocBeginShortcutMenuOsnap(Sender: TObject; AMenu: OleVariant);
    procedure OnDocEndShortcutMenu(Sender: TObject; AMenu: OleVariant);
    procedure OnDocBeginDoubleClick(Sender: TObject; APickPoint: OleVariant);
    procedure OnDocObjectAdded(Sender: TObject; AObject: OleVariant);
    procedure OnDocObjectErased(Sender: TObject; AObjectID: Integer);
    procedure OnDocObjectModified(Sender: TObject; AObject: OleVariant);
    procedure OnDocBeginPlot(Sender: TObject; const ADrawingName: WideString);
    procedure OnDocEndPlot(Sender: TObject; const ADrawingName: WideString);
    procedure OnDocWindowMoved(Sender: TObject; AHandle: Integer; AMoved: WordBool);
    procedure OnDocLayoutSwitched(Sender: TObject; const ALayoutName: WideString);
    procedure OnDocWindowChanged(Sender: TObject; AState: TOleEnum);
    procedure OnDocBeginClose(Sender: TObject);
    procedure OnDocBeginDocClose(Sender: TObject; var ACancel: WordBool);
    procedure OnDocUnknownEvent(Sender: TObject; ADispID: TDispID);
    procedure btnClearClick(Sender: TObject);
  private

  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

uses
  AcadEvents;

procedure TfrmMain.btnConnectClick(Sender: TObject);
begin
  if AcadConnect(True) then
  begin
    pnlCtrl.Caption:= 'C...';
    btnConnect.Enabled:= False;
    // Application Events
    AcadAppEvents.OnSysVarChanged:= OnAppSysVarChanged;
    AcadAppEvents.OnNewDrawing:= OnAppNewDrawing;
    AcadAppEvents.OnAppActivate:= OnAppAppActivate;
    AcadAppEvents.OnAppDeactivate:= OnAppAppDeactivate;
    AcadAppEvents.OnWindowMovedOrResized:= OnAppWindowMoved;
    AcadAppEvents.OnBeginModal:= OnAppBeginModal;
    AcadAppEvents.OnEndModal:= OnAppEndModal;
    AcadAppEvents.OnBeginQuit:= OnAppBeginQuit;
    AcadAppEvents.OnBeginFileDrop:= OnAppBeginFileDrop;
    AcadAppEvents.OnArxLoaded:= OnAppArxLoaded;
    AcadAppEvents.OnArxUnloaded:= OnAppArxUnloaded;
    AcadAppEvents.OnBeginPlot:= OnAppBeginPlot;
    AcadAppEvents.OnEndPlot:= OnAppEndPlot;
    AcadAppEvents.OnBeginLisp:= OnAppBeginLisp;
    AcadAppEvents.OnEndLisp:= OnAppEndLisp;
    AcadAppEvents.OnBeginCommand:= OnAppBeginCommand;
    AcadAppEvents.OnEndCommand:= OnAppEndCommand;
    AcadAppEvents.OnBeginSave:= OnAppBeginSave;
    AcadAppEvents.OnEndSave:= OnAppEndSave;
    AcadAppEvents.OnBeginOpen:= OnAppBeginOpen;
    AcadAppEvents.OnEndOpen:= OnAppEndOpen;
    AcadAppEvents.OnLispCancelled:= OnAppLispCancelled;
    AcadAppEvents.OnWindowChanged:= OnAppWindowChanged;
    AcadAppEvents.OnUnknownEvent:= OnAppUnknownEvent;
    // Document Events
    AcadDocEvents.OnBeginSave:= OnDocBeginSave;
    AcadDocEvents.OnEndSave:= OnDocEndSave;
    AcadDocEvents.OnBeginCommand:= OnDocBeginCommand;
    AcadDocEvents.OnEndCommand:= OnDocEndCommand;
    AcadDocEvents.OnBeginLisp:= OnDocBeginLisp;
    AcadDocEvents.OnEndLisp:= OnDocEndLisp;
    AcadDocEvents.OnLispCancelled:= OnDocLispCancelled;
    AcadDocEvents.OnSelectionChanged:= OnDocSelectionChanged;
    AcadDocEvents.OnActivate:= OnDocActivate;
    AcadDocEvents.OnDeactivate:= OnDocDeactivate;
    AcadDocEvents.OnBeginRightClick:= OnDocBeginRightClick;
    AcadDocEvents.OnBeginShortcutMenuDefault:= OnDocBeginShortcutMenuDefault;
    AcadDocEvents.OnBeginShortcutMenuEdit:= OnDocBeginShortcutMenuEdit;
    AcadDocEvents.OnBeginShortcutMenuCommand:= OnDocBeginShortcutMenuCommand;
    AcadDocEvents.OnBeginShortcutMenuGrip:= OnDocBeginShortcutMenuGrip;
    AcadDocEvents.OnBeginShortcutMenuOsnap:= OnDocBeginShortcutMenuOsnap;
    AcadDocEvents.OnEndShortcutMenu:= OnDocEndShortcutMenu;
    AcadDocEvents.OnBeginDoubleClick:= OnDocBeginDoubleClick;
    AcadDocEvents.OnObjectAdded:= OnDocObjectAdded;
    AcadDocEvents.OnObjectErased:= OnDocObjectErased;
    AcadDocEvents.OnObjectModified:= OnDocObjectModified;
    AcadDocEvents.OnBeginPlot:= OnDocBeginPlot;
    AcadDocEvents.OnEndPlot:= OnDocEndPlot;
    AcadDocEvents.OnWindowMovedOrResized:= OnDocWindowMoved;
    AcadDocEvents.OnLayoutSwitched:= OnDocLayoutSwitched;
    AcadDocEvents.OnWindowChanged:= OnDocWindowChanged;
    AcadDocEvents.OnBeginClose:= OnDocBeginClose;
    AcadDocEvents.OnBeginDocClose:= OnDocBeginDocClose;
    AcadDocEvents.OnUnknownEvent:= OnDocUnknownEvent;
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Caption:= Application.Title;
  AcadAppEvents:= TAcadApplicationEvents.Create(Self);
  AcadDocEvents:= TAcadDocumentEvents.Create(Self);
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  AcadDisConnect;
  AcadDocEvents.Free;
  AcadAppEvents.Free;
end;

procedure TfrmMain.btnClearClick(Sender: TObject);
begin
  memLog.Lines.Clear;
end;

   //////////////////         Application Events         //////////////////

procedure TfrmMain.OnAppSysVarChanged(Sender: TObject; const AName: WideString;
  AValue: OleVariant);
var
  i, LBnd, HBnd: Longint;
  S: String;
begin
  if not VarIsArray(AValue) then
    S:= VarToStr(AValue)
  else begin
    LBnd:= VarArrayLowBound(AValue, 1);
    HBnd:= VarArrayHighBound(AValue, 1);
    S:= '';
    for i:= LBnd to (HBnd - LBnd) + 0 do
    begin
      if S = '' then
        S:= Format('%s', [VarToStr(AValue[i])])
      else
        S:= S + Format('; %s', [VarToStr(AValue[i])]);
    end;
  end;
  memLog.Lines.Add(Format('SysVarChanged "%s" [%s]', [AName, S]));
end;

procedure TfrmMain.OnAppNewDrawing(Sender: TObject);
begin
  memLog.Lines.Add('NewDrawing');
end;

procedure TfrmMain.OnAppAppActivate(Sender: TObject);
begin
  memLog.Lines.Add('AppActivate');
end;

procedure TfrmMain.OnAppAppDeactivate(Sender: TObject);
begin
  memLog.Lines.Add('AppDeactivate');
end;

procedure TfrmMain.OnAppWindowMoved(Sender: TObject; AHandle: Integer;
  AMoved: WordBool);
begin
  memLog.Lines.Add(Format('WindowMoved "%d", "%s"', [AHandle, BoolToStr(Boolean(AMoved), True)]));
end;

procedure TfrmMain.OnAppBeginModal(Sender: TObject);
begin
  memLog.Lines.Add('BeginModal');
end;

procedure TfrmMain.OnAppEndModal(Sender: TObject);
begin
  memLog.Lines.Add('EndModal');
end;

procedure TfrmMain.OnAppBeginQuit(Sender: TObject; var ACancel: WordBool);
begin
  memLog.Lines.Add(Format('BeginQuit "%s"', [BoolToStr(Boolean(ACancel), True)]));
end;

procedure TfrmMain.OnAppBeginFileDrop(Sender: TObject;
  const AName: WideString; var ACancel: WordBool);
begin
  memLog.Lines.Add(Format('BeginFileDrop "%s", "%s"', [AName, BoolToStr(Boolean(ACancel), True)]));
end;

procedure TfrmMain.OnAppArxLoaded(Sender: TObject;
  const AAppName: WideString);
begin
  memLog.Lines.Add(Format('ArxLoaded "%s"', [AAppName]));
end;

procedure TfrmMain.OnAppArxUnloaded(Sender: TObject;
  const AAppName: WideString);
begin
  memLog.Lines.Add(Format('ArxUnloaded "%s"', [AAppName]));
end;

procedure TfrmMain.OnAppBeginLisp(Sender: TObject;
  const AFirstLine: WideString);
begin
  memLog.Lines.Add(Format('BeginLisp "%s"', [AFirstLine]));
end;

procedure TfrmMain.OnAppEndLisp(Sender: TObject);
begin
  memLog.Lines.Add('EndLisp');
end;

procedure TfrmMain.OnAppBeginCommand(Sender: TObject;
  const ACommand: WideString);
begin
  memLog.Lines.Add(Format('BeginCommand "%s"', [ACommand]));
end;

procedure TfrmMain.OnAppEndCommand(Sender: TObject;
  const ACommand: WideString);
begin
  memLog.Lines.Add(Format('EndCommand "%s"', [ACommand]));
end;

procedure TfrmMain.OnAppBeginOpen(Sender: TObject;
  const AFileName: WideString);
begin
  memLog.Lines.Add(Format('BeginOpen "%s"', [AFileName]));
end;

procedure TfrmMain.OnAppEndOpen(Sender: TObject;
  const AFileName: WideString);
begin
  memLog.Lines.Add(Format('EndOpen "%s"', [AFileName]));
end;

procedure TfrmMain.OnAppBeginPlot(Sender: TObject;
  const ADrawingName: WideString);
begin
  memLog.Lines.Add(Format('BeginPlot "%s"', [ADrawingName]));
end;

procedure TfrmMain.OnAppEndPlot(Sender: TObject;
  const ADrawingName: WideString);
begin
  memLog.Lines.Add(Format('EndPlot "%s"', [ADrawingName]));
end;

procedure TfrmMain.OnAppBeginSave(Sender: TObject;
  const AFileName: WideString);
begin
  memLog.Lines.Add(Format('BeginSave "%s"', [AFileName]));
end;

procedure TfrmMain.OnAppEndSave(Sender: TObject;
  const AFileName: WideString);
begin
  memLog.Lines.Add(Format('EndSave "%s"', [AFileName]));
end;

procedure TfrmMain.OnAppLispCancelled(Sender: TObject);
begin
  memLog.Lines.Add('LispCancelled');
end;

procedure TfrmMain.OnAppWindowChanged(Sender: TObject; AState: TOleEnum);
begin
  memLog.Lines.Add(Format('WindowChanged "%d"', [AState]));
end;

procedure TfrmMain.OnAppUnknownEvent(Sender: TObject; ADispID: TDispID);
begin
  memLog.Lines.Add(Format('UnknownEvent "%d"', [ADispID]));
end;

   //////////////////           Document Events          //////////////////

procedure TfrmMain.OnDocActivate(Sender: TObject);
begin
  memLog.Lines.Add(#9'Activate');
end;

procedure TfrmMain.OnDocBeginCommand(Sender: TObject; const ACommand: WideString);
begin
  memLog.Lines.Add(Format(#9'BeginCommand "%s"', [ACommand]));
end;

procedure TfrmMain.OnDocBeginLisp(Sender: TObject; const AFirstLine: WideString);
begin
  memLog.Lines.Add(Format(#9'BeginLisp "%s"', [AFirstLine]));
end;

procedure TfrmMain.OnDocBeginRightClick(Sender: TObject;
  APickPoint: OleVariant);
begin
  memLog.Lines.Add(Format(#9'BeginRightClick [%f; %f; %f]', [Double(APickPoint[0]), Double(APickPoint[1]), Double(APickPoint[2])]));
end;

procedure TfrmMain.OnDocBeginSave(Sender: TObject; const AFileName: WideString);
begin
  memLog.Lines.Add(Format(#9'BeginSave "%s"', [AFileName]));
end;

procedure TfrmMain.OnDocBeginShortcutMenuDefault(Sender: TObject; AMenu: OleVariant);
begin
  memLog.Lines.Add(Format(#9'BeginShortcutMenuDefault "%s"', [AMenu.Name]));
end;

procedure TfrmMain.OnDocBeginShortcutMenuEdit(Sender: TObject; AMenu,
  ASet: OleVariant);
begin
  memLog.Lines.Add(Format(#9'BeginShortcutMenuEdit "%s" SelectionSet "%s"', [AMenu.Name, ASet.Name]));
end;

procedure TfrmMain.OnDocDeactivate(Sender: TObject);
begin
  memLog.Lines.Add(#9'Deactivate');
end;

procedure TfrmMain.OnDocEndCommand(Sender: TObject; const ACommand: WideString);
begin
  memLog.Lines.Add(Format(#9'EndCommand "%s"', [ACommand]));
end;

procedure TfrmMain.OnDocEndLisp(Sender: TObject);
begin
  memLog.Lines.Add(#9'EndLisp');
end;

procedure TfrmMain.OnDocEndSave(Sender: TObject; const AFileName: WideString);
begin
  memLog.Lines.Add(Format(#9'EndSave "%s"', [AFileName]));
end;

procedure TfrmMain.OnDocLispCancelled(Sender: TObject);
begin
  memLog.Lines.Add(#9'LispCancelled');
end;

procedure TfrmMain.OnDocSelectionChanged(Sender: TObject);
begin
  memLog.Lines.Add(#9'SelectionChanged');
end;

procedure TfrmMain.OnDocBeginShortcutMenuCommand(Sender: TObject;
  AMenu: OleVariant; const ACommand: WideString);
begin
  memLog.Lines.Add(Format(#9'BeginShortcutMenuCommand "%s" Command "%s"', [AMenu.Name, ACommand]));
end;

procedure TfrmMain.OnDocBeginShortcutMenuGrip(Sender: TObject;
  AMenu: OleVariant);
begin
  memLog.Lines.Add(Format(#9'BeginShortcutMenuGrip "%s"', [AMenu.Name]));
end;

procedure TfrmMain.OnDocBeginShortcutMenuOsnap(Sender: TObject;
  AMenu: OleVariant);
begin
  memLog.Lines.Add(Format(#9'BeginShortcutMenuOsnap "%s"', [AMenu.Name]));
end;

procedure TfrmMain.OnDocEndShortcutMenu(Sender: TObject; AMenu: OleVariant);
begin
  memLog.Lines.Add(Format(#9'EndShortcutMenu "%s"', [AMenu.Name]));
end;

procedure TfrmMain.OnDocBeginDoubleClick(Sender: TObject;
  APickPoint: OleVariant);
begin
  memLog.Lines.Add(Format(#9'BeginDoubleClick [%f; %f; %f]', [Double(APickPoint[0]), Double(APickPoint[1]), Double(APickPoint[2])]));
end;

procedure TfrmMain.OnDocObjectAdded(Sender: TObject; AObject: OleVariant);
begin
  memLog.Lines.Add(Format(#9'ObjectAdded "%s"', [AObject.ObjectName]));
end;

procedure TfrmMain.OnDocObjectErased(Sender: TObject; AObjectID: Integer);
begin
  memLog.Lines.Add(Format(#9'ObjectErased "%d"', [AObjectID]));
end;

procedure TfrmMain.OnDocObjectModified(Sender: TObject; AObject: OleVariant);
begin
  memLog.Lines.Add(Format(#9'ObjectModified "%s"', [AObject.ObjectName]));
end;

procedure TfrmMain.OnDocBeginPlot(Sender: TObject;
  const ADrawingName: WideString);
begin
  memLog.Lines.Add(Format(#9'BeginPlot "%s"', [ADrawingName]));
end;

procedure TfrmMain.OnDocEndPlot(Sender: TObject;
  const ADrawingName: WideString);
begin
  memLog.Lines.Add(Format(#9'EndPlot "%s"', [ADrawingName]));
end;

procedure TfrmMain.OnDocWindowMoved(Sender: TObject; AHandle: Integer;
  AMoved: WordBool);
begin
  memLog.Lines.Add(Format(#9'WindowMoved "%d", "%s"', [AHandle, BoolToStr(Boolean(AMoved), True)]));
end;

procedure TfrmMain.OnDocLayoutSwitched(Sender: TObject;
  const ALayoutName: WideString);
begin
  memLog.Lines.Add(Format(#9'LayoutSwitched "%s"', [ALayoutName]));
end;

procedure TfrmMain.OnDocWindowChanged(Sender: TObject; AState: TOleEnum);
begin
  memLog.Lines.Add(Format(#9'WindowChanged "%d"', [AState]));
end;

procedure TfrmMain.OnDocBeginClose(Sender: TObject);
begin
  memLog.Lines.Add(#9'BeginClose');
end;

procedure TfrmMain.OnDocBeginDocClose(Sender: TObject; var ACancel: WordBool);
begin
  memLog.Lines.Add(Format(#9'BeginDocClose "%s"', [BoolToStr(Boolean(ACancel), True)]));
end;

procedure TfrmMain.OnDocUnknownEvent(Sender: TObject; ADispID: TDispID);
begin
  memLog.Lines.Add(#9'UnknownEvent "%d"' + IntToStr(ADispID));
end;

end.
